% inputs
%gis_fluid_finite_3state_Esingular

n = size(Q,1);

% first regime: 0 < x < a

P = [ zeros(1,1+L*n); ...
    kron(T0,ones(n,1)), kron(eye(L),Q) + kron(T_h,eye(n)) ];
D1 = blkdiag(1,kron(eye(L),R));
D1_= blkdiag(1,kron(eye(L),R_));
A1=P*D1_;


right = D1*ones(1+L*n,1);
e1=[1; zeros(L*n,1)];
u = right- norm(right,2)*e1;
Q1 = eye(1+L*n) - 2*u*u'/(u'*u);
temp=Q1*A1*Q1;
P1tilde=temp(2:1+L*n,2:1+L*n);
[U,T] = schur(P1tilde);
[U,T] = ordschur(U,T,'lhp');
Q=Q1*blkdiag(1,U);

T=Q'*A1*Q;

   n_neg1 = S_plus*L;
   n_pos1 = S_minus*L;


% % there needs to be exactly one zero eigenvalue
% % but it may appear as a very small nonzero number
% T( abs(T)<1e-12 ) = 0;
% [U,T] = ordschur(U,T,ordeig(T)==0);
% n_neg1 = sum(real(ordeig(T))<0);
% n_pos1 = sum(real(ordeig(T))>0);
% % sanity check
% if n_neg1+n_pos1+1 ~= n*L+1
%     disp('eig number error')
%     return
% end

% block-diagonalize
X1 = -T(1,2:end) / T(2:end,2:end);
temp1=-T(2:n_neg1+1,2:n_neg1+1);
temp2=T(n_neg1+2:end,n_neg1+2:end);
temp3= -T(2:n_neg1+1,n_neg1+2:end);
X2 = sylvester(temp1,temp2,temp3);

Y1_ = [1 zeros(1,n*L); zeros(n_neg1,1) eye(n_neg1) X2; zeros(n_pos1,n_neg1+1) eye(n_pos1)] *...
    [1 X1;zeros(n*L,1) eye(n*L)] * Q';
% Y1_ is the inverse of Y1
Y1= Q*[1 -X1;zeros(n*L,1) eye(n*L)]* [1 zeros(1,n*L); zeros(n_neg1,1) eye(n_neg1) -X2; 
    zeros(n_pos1,n_neg1+1) eye(n_pos1)]; 

A1_ = Y1_ * A1 * Y1;
Aneg1 = A1_(2:n_neg1+1,2:n_neg1+1);
offdiag23=A1_(2:n_neg1+1,n_neg1+2:end);
offdiag21=A1_(2:n_neg1+1,1);
Apos1 = A1_(n_neg1+2:end,n_neg1+2:end);
offdiag31= A1_(n_neg1+2:end,1);
offdiag32=A1_(n_neg1+2:end,2:n_neg1+1);


% second regime: x > a

D2 = blkdiag(-1,kron(eye(L),R));
D2_= blkdiag(-1,kron(eye(L),R_));
A2=P*D2_;


right = D2*ones(1+L*n,1);
e1=[1; zeros(L*n,1)];
u = right- norm(right,2)*e1;
Q1 = eye(1+L*n) - 2*u*u'/(u'*u);
temp=Q1*A2*Q1;
P1tilde=temp(2:1+L*n,2:1+L*n);
[U,T] = schur(P1tilde);
[U,T] = ordschur(U,T,'lhp');
Q=Q1*blkdiag(1,U);

T=Q'*A2*Q;


   n_neg2 = S_plus*L;
   n_pos2 = S_minus*L;


% % there needs to be exactly one zero eigenvalue
% % but it may appear as a very small nonzero number
% T( abs(T)<1e-12 ) = 0;
% [U,T] = ordschur(U,T,ordeig(T)==0);
% n_neg1 = sum(real(ordeig(T))<0);
% n_pos1 = sum(real(ordeig(T))>0);
% % sanity check
% if n_neg1+n_pos1+1 ~= n*L+1
%     disp('eig number error')
%     return
% end

% block-diagonalize
X1 = -T(1,2:end) / T(2:end,2:end);
temp1=-T(2:n_neg1+1,2:n_neg1+1);
temp2=T(n_neg1+2:end,n_neg1+2:end);
temp3= -T(2:n_neg1+1,n_neg1+2:end);
X2 = sylvester(temp1,temp2,temp3);

Y2_ = [1 zeros(1,n*L); zeros(n_neg1,1) eye(n_neg1) X2; zeros(n_pos1,n_neg1+1) eye(n_pos1)] *...
    [1 X1;zeros(n*L,1) eye(n*L)] * Q';
% Y1_ is the inverse of Y1
Y2= Q*[1 -X1;zeros(n*L,1) eye(n*L)]* [1 zeros(1,n*L); zeros(n_neg1,1) eye(n_neg1) -X2; 
    zeros(n_pos1,n_neg1+1) eye(n_pos1)]; 

A2_ = Y2_ * A2 * Y2;
Aneg2 = A2_(2:n_neg1+1,2:n_neg1+1);
offdiag23=A2_(2:n_neg1+1,n_neg1+2:end);
offdiag21=A2_(2:n_neg1+1,1);
Apos2 = A2_(n_neg1+2:end,n_neg1+2:end);
offdiag31= A2_(n_neg1+2:end,1);
offdiag32=A2_(n_neg1+2:end,2:n_neg1+1);


% P the same with first regime
% D2 = blkdiag(-1,kron(eye(L),R));
% A = P / D2 ;
% 
% [U,T] = schur(A);
% [U,T] = ordschur(U,T,'lhp');
% % there needs to be exactly one zero eigenvalue
% % but it may appear as a very small nonzero number
% T( abs(T)<1e-12 ) = 0;
% [U,T] = ordschur(U,T,ordeig(T)==0);
% n_neg2 = sum(real(ordeig(T))<0);
% n_pos2 = sum(real(ordeig(T))>0);
% % sanity check
% if n_neg2+n_pos2+1 ~= n*L+1
%     disp('eig number error')
%     return
% end
% 
% X1 = -T(1,2:end) / T(2:end,2:end);
% X2 = lyap( -T(2:n_neg2+1,2:n_neg2+1), ...
%     T(n_neg2+2:end,n_neg2+2:end), ...
%     T(2:n_neg2+1,n_neg2+2:end) );
% 
% Y2 = [1 zeros(1,n*L); zeros(n_neg2,1) eye(n_neg2) X2; zeros(n_pos2,n_neg2+1) eye(n_pos2)] *...
%     [1 X1;zeros(n*L,1) eye(n*L)] * U';
% 
% A = Y2 * A / Y2;
% Aneg2 = A(2:n_neg2+1,2:n_neg2+1);
% Apos2 = A(n_neg2+2:end,n_neg2+2:end);


%----------------------------------

% solve for coefficients

% c0: masses at 0 due to states with r<0
% cA: mass at a due to state A
% c2: masses at B due to states with r>0
% a1, a2: coeff. in regimes 1 and 2

c0len = L * sum( diag(R)<0 );
c2len = L * sum( diag(R)>0 );
iden = eye(n*L+1);

BndCndMatrix = [ ...
    iden([0;diag(D1(2:end,2:end))]<0,:) * P, ...
    zeros( sum(diag(D1(2:end,2:end))<0), 2*(n*L+1) ); ...
    ...
    -blkdiag( eye(n_neg1+1), expm(-Apos1*a) )*Y1_*D1, ...
    blkdiag( 1, expm(Aneg1*a), eye(n_pos1) )*Y1_*D1,  zeros(n*L+1); ...
    ...
    zeros(1, n*L+1), -1, kron(v,pi0), zeros(1, n*L+1) ; ...
    ...
    zeros(n*L+1), ...
    -blkdiag( eye(n_neg2+1), expm(Apos2*(a-B)) )*Y2_*D2, ...
    blkdiag( 1, expm(Aneg2*(B-a)), eye(n_pos2) )*Y2_*D2; ...
    ...
    zeros( sum(diag(D2(2:end,2:end))>0), 2*(n*L+1) ), ...
    iden([0;diag(D2(2:end,2:end))]>0,:) * P ];


coef = [1, zeros(1,size(BndCndMatrix,1)-1)] / ...
    [[1;zeros(size(BndCndMatrix,1)-1,1)],BndCndMatrix(:,2:end)];

% c0: masses at 0 due to states with r<0
c0 = coef(1:c0len);
i = c0len+1;
% a1: coeff. in regime 1
a1 = coef(i:i+(n*L+1)-1);
i = i + (n*L+1);
% cA: mass at a due to state A
cA = coef(i);
i = i + 1;
% a2: coeff. in regime 2
a2 = coef(i:i+(n*L+1)-1);
i = i + (n*L+1);
% c2: masses at B due to states with r>0
c2 = coef(i:end);

% Normalize
FB = a1(1) * Y1(1,:) * a + ...
    a1(2:n_neg1+1) * (expm(Aneg1*a)-expm(Aneg1*0)) / Aneg1 * Y1_(2:n_neg1+1,:) + ...
    a1(n_neg1+2:end) * (expm(Apos1*0)-expm(Apos1*(-a))) / Apos1 * Y1_(n_neg1+2:end,:) + ...
    ...
    a2(1) * Y2(1,:) * (B-a) + ...
    a2(2:n_neg2+1) * (expm(Aneg2*(B-a))-expm(Aneg2*0)) / Aneg2 * Y2_(2:n_neg2+1,:) + ...
    a2(n_neg2+2:end) * (expm(Apos2*0)-expm(Apos2*(a-B))) / Apos2 * Y2_(n_neg2+2:end,:) ;
FB = FB + c0 * iden(diag(D1)<0,:);
FB = FB + c2 * iden(diag(D2)>0,:);
FB = FB + [cA, zeros(1,n*L)];
Tot = sum(FB);
FB = FB / Tot;

a1 = a1 / Tot;
a2 = a2 / Tot;
c0 = c0 / Tot;
c0size=size(c0,2);
cA = cA / Tot;
c2 = c2 / Tot;
c2size=size(c2,2);



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

ccdfvec=xvec;
for i=1:size(xvec,1)
    x=xvec(i);
% cdf at x
if x <= a
    Fx = a1(1) * Y1(1,:) * x + ...
        a1(2:n_neg1+1) * (expm(Aneg1*x)-expm(Aneg1*0)) / Aneg1 * Y1_(2:n_neg1+1,:) + ...
        a1(n_neg1+2:end) * -(expm(Apos1*(-a))-expm(Apos1*(x-a))) / Apos1 * Y1_(n_neg1+2:end,:);
    Fx = Fx + c0 * iden(diag(D1)<0,:);
    if x == a
        Fx = Fx + [cA, zeros(1,n*L)];
    end
    
else % x>a
    Fx = a1(1) * Y1(1,:) * a + ...
        a1(2:n_neg1+1) * (expm(Aneg1*a)-expm(Aneg1*0)) / Aneg1 * Y1_(2:n_neg1+1,:) + ...
        a1(n_neg1+2:end) * (expm(Apos1*0)-expm(Apos1*(-a))) / Apos1 * Y1_(n_neg1+2:end,:) + ...
        a2(1) * Y2(1,:) * (x-a) + ...
        a2(2:n_neg2+1) * (expm(Aneg2*(x-a))-expm(Aneg2*0)) / Aneg2 * Y2_(2:n_neg2+1,:) + ...
        a2(n_neg2+2:end) * (expm(Apos2*(x-B))-expm(Apos2*(a-B))) / Apos2 * Y2_(n_neg2+2:end,:) ;
    Fx = Fx + c0 * iden(diag(D1)<0,:);
    % comment out the if block below for result at B- instead of B
% % %     if x == B
% % %         Fx = Fx + c2 * iden(diag(D2)>0,:);
% % %     end
    Fx = Fx + [cA, zeros(1,n*L)];
end

ccdf = 1-(  Fx(2:end) * P(2:end,1)  )  /  (  FB(2:end) * P(2:end,1)  );
ccdfvec(i)=ccdf;
end
% fprintf('%d\t\t%.8f\n',x,ccdf)
final=[xvec ccdfvec]


   
   


