function res = model_so(sigma, v, T_h)

if ~exist('sigma','var')
    sigma = 0;
end

util = 0.95;
K=10;
T_on = 2;
C_onsquared = 4*4;
source_rho = 0.4;
r = 1;

% construct the single source parameters

% from Tijms
p_1 = 0.5*(1 + sqrt((C_onsquared-1)/(C_onsquared+1)));
p_2 = 1-p_1;
mu_1 = 2*p_1 / T_on;
mu_2 = 2*p_2 / T_on;

T_off = (1 - source_rho)*T_on / source_rho;

r_10 = mu_1;
r_20 = mu_2;
r_01 = p_1/T_off;
r_02 = p_2/T_off;

C = K*source_rho*r/ util;
B = 100;
fix = 1;

S_minus = 0;
S_plus = 0;
S =(K+1)*(K+2)/2;
N = S-1;
A = zeros(N+1,N+1);
E = zeros(N+1,N+1);
V = zeros(N+1,N+1);
for n1=0:K
   for n2=0:K-n1
      
      temp = n1*(K+1) - n1*(n1-1)/2 + (n2+1);
      
      E(temp,temp) = (n1+n2)*r - C;
      V(temp,temp) = (n1+n2)*sigma;
      if(E(temp,temp)>0) 
          S_plus = S_plus + 1;
         
      else
          S_minus =S_minus + 1;
      end
      
      
      temp1 = n1*(K+1) - n1*(n1-1)/2 + (n2+2);
      temp2 = (n1+1)*(K+1) - (n1+1)*(n1)/2 + (n2+1);
      temp3 = n1*(K+1) - n1*(n1-1)/2 + (n2);
      temp4 = (n1-1)*(K+1) - (n1-1)*(n1-2)/2 + (n2+1);
         
      
      
      if(n1==0 && n2==0)
         A(temp,temp1) = (K-n1-n2)*r_02;
         A(temp,temp2) = (K-n1-n2)*r_01;
         % A(temp,temp3) =  n2*r_20;
         % A(temp,temp4) = n1*r_10;
         A(temp,temp) = -(A(temp,temp1) + A(temp,temp2));
      elseif(n1==0 && n2==K)
         % A(temp,temp1) = (K-n1-n2)*r_02;
         % A(temp,temp2) = (K-n1-n2)*r_01;
         A(temp,temp3) =  n2*r_20;
         % A(temp,temp4) = n1*r_10;
         A(temp,temp) = -(A(temp,temp3));
      elseif(n1==0 && 0<n2<K )
         A(temp,temp1) = (K-n1-n2)*r_02;
         A(temp,temp2) = (K-n1-n2)*r_01;
         A(temp,temp3) =  n2*r_20;
         % A(temp,temp4) = n1*r_10;
         A(temp,temp) = -(A(temp,temp1) + A(temp,temp2) + A(temp,temp3));
      elseif(n1==K && n2==0)
         % A(temp,temp1) = (K-n1-n2)*r_02;
         %A(temp,temp2) = (K-n1-n2)*r_01;
         % A(temp,temp3) =  n2*r_20;
         A(temp,temp4) = n1*r_10;
         A(temp,temp) = -(A(temp,temp4));
      %elseif(n1==K & n2==K) 
         % A(temp,temp1) = (K-n1-n2)*r_02;
         % A(temp,temp2) = (K-n1-n2)*r_01;
         % A(temp,temp3) =  n2*r_20;
         % A(temp,temp4) = n1*r_10;
         % A(temp,temp) = -(A(temp,temp3) + A(temp,temp4));
      %elseif(n1==K & 0<n2<K)
         %  A(temp,temp1) = (K-n1-n2)*r_02;
         % A(temp,temp2) = (K-n1-n2)*r_01;
         % A(temp,temp3) =  n2*r_20;
         % A(temp,temp4) = n1*r_10;
         % A(temp,temp) = -(A(temp,temp1) + A(temp,temp3) + A(temp,temp4));
      elseif(0<n1<K && n2==0)
         A(temp,temp1) = (K-n1-n2)*r_02;
         A(temp,temp2) = (K-n1-n2)*r_01;
         % A(temp,temp3) =  n2*r_20;
         A(temp,temp4) = n1*r_10;
         A(temp,temp) = -(A(temp,temp1) + A(temp,temp2) + A(temp,temp4));
      %elseif(0<n1<K & n2==K)
         % A(temp,temp1) = (K-n1-n2)*r_02;
       %  A(temp,temp2) = (K-n1-n2)*r_01;
       %  A(temp,temp3) =  n2*r_20;
       %  A(temp,temp4) = n1*r_10;
        % A(temp,temp) = -(A(temp,temp2) + A(temp,temp3) + A(temp,temp4));
     else
        temp5 = 0;
         if(K ~= n1+n2) 
            A(temp,temp1) = (K-n1-n2)*r_02; 
            A(temp,temp2) = (K-n1-n2)*r_01; 
            temp5 = A(temp,temp1) + A(temp,temp2);
         end
         

         A(temp,temp3) =  n2*r_20;
         A(temp,temp4) = n1*r_10;
         A(temp,temp) = -(temp5 + A(temp,temp3) + A(temp,temp4));
         
         
     end
   end
end

      

T_bar = zeros(N+1,S_plus);
N_bar = zeros(N+1,S_minus);
overload = 0;
underload = 0;
for n1=0:K
   for n2=0:K-n1
      temp = n1*(K+1) - n1*(n1-1)/2 + (n2+1);
       if(E(temp,temp)>0)
          overload = overload +1;
          T_bar(temp,overload) = 1;     
       else 
           underload = underload +1;
           N_bar(temp,underload)=1;
        end
   end
end

     
% A x_null = 0;
e = ones(N+1,1);
x_null = e;
x_null = x_null / (N+1);


% y_null A = 0;
y_null = null(A')';
y_null = y_null / sum(y_null);



% find the average drift d

d = y_null* diag(E);

% M_stable: number of stable eigenvalues
% M_unstable: number of strictly unstable eigenvalues


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Q=A;
R=E;
S=V;

% queue capacity

% initial buffer level > 0
a = 1e-12;

% time horizon > 0
h = 10^2;

% initial distribution
pi0 = [1,zeros(1,size(Q,1)-1)]/[ones(size(Q,1),1),Q(:,2:end)];
pi0(diag(R)<=0) = 0;
pi0 = pi0 / sum(pi0);

% % horizon PH: Erlang-L
% L = 7;
% T_h = -diag(L/h*ones(L,1)) + [zeros(L-1,1), diag(L/h*ones(L-1,1)); zeros(1,L)];
% v = [1, zeros(1,L-1)];
% T0 = -T_h * ones(L,1); %%% -sum(T,2);

% horizon ME
if ~exist('v','var')
    run('me_1_74.m');
    v = b3;
    T_h = B3;
end
mn = v*sum(inv(-T_h),2);
T_h = T_h*mn/h;
T0 = -sum(T_h, 2);
L = length(v);

% find cdf at
%xvec = [0 10 20 30 40 50 60 70 80 90 100]'/ 100 * B;
xvec = (0:0.01:1)' * B;

n = size(Q,1);

Q1 = [ zeros(1,1+L*n); kron(T0,ones(n,1)), kron(eye(L),Q) + kron(T_h,eye(n)) ];
R1 = blkdiag(1,kron(eye(L),R));

Q2 = [ zeros(1,1+L*n); kron(T0,ones(n,1)), kron(eye(L),Q) + kron(T_h,eye(n)) ];
R2 = blkdiag(-1,kron(eye(L),R));

Q12 = [-1, kron(v,pi0); zeros(L*n,1+L*n)];
R12 = blkdiag(0,kron(eye(L),R));

S = blkdiag(0,kron(eye(L),S));

% calling the generic multi-regime solver
T = [a,B];

[masses, iniF, KF, cloF, iniB, KB, cloB] = SecondOrderLevelDependentFluidSolve ({Q1,Q2}, {R1,R2}, {S, S}, T, [], [], {Q1,Q12,Q2});
cdfm = LevelDependentFluidStationaryDistr (masses, iniF, KF, cloF, iniB, KB, cloB, T, 'cdfm', xvec);

nrm = cdfm(end,2:end)*kron(T0,ones(n,1));
res = 1-cdfm(1:end,2:end)*kron(T0,ones(n,1))/nrm;
res(end) = masses{end}(2:end)*kron(T0,ones(n,1))/nrm;

